//Bf2 Rank Mod Stocks File

#if defined jhd_stocks_included
#endinput
#endif
#define jhd_stocks_included

#if cellbits == 32
#define OFFSET_CSMONEY  115
#else
#define OFFSET_CSMONEY  140
#endif

#define OFFSET_LINUX      5
#define OFFSET_ARMORTYPE 112
#define OFFSET_DEFUSE_PLANT		193
#define PLAYER_IS_VIP    (1 << 8)
#define OFFSET_VIP    209
#define OFFSET_TEAM 114

#define fm_get_user_armor(%1) get_pdata_int( %1, OFFSET_ARMORTYPE )

enum CsTeams
{
    CS_TEAM_UNASSIGNED = 0,
    CS_TEAM_T = 1,
    CS_TEAM_CT = 2,
    CS_TEAM_SPECTATOR = 3
}

stock fm_set_user_money(id,money,flash=0)
{
	set_pdata_int(id,OFFSET_CSMONEY,money,OFFSET_LINUX);
	
	message_begin(MSG_ONE,get_user_msgid("Money"),{0,0,0},id);
	write_long(money);
	write_byte(flash);
	message_end();
}

stock fm_get_user_money(id)
{
	return get_pdata_int(id,OFFSET_CSMONEY,OFFSET_LINUX);
}

stock fm_get_user_health(id)
{
    return pev(id, pev_health)
} 

stock fm_get_user_vip(id)
{
    return get_pdata_int(id, OFFSET_VIP) & PLAYER_IS_VIP;
}

stock fm_set_user_team(id, CsTeams:team)
{
    set_pdata_int(id, OFFSET_TEAM, _:team)

    dllfunc(DLLFunc_ClientUserInfoChanged, id)

    static teaminfo[12], iMsgid_TeamInfo
    switch(team)
    {
        case CS_TEAM_UNASSIGNED:
            teaminfo="UNASSIGNED"
        case CS_TEAM_T:
            teaminfo="TERRORIST"
        case CS_TEAM_CT:
            teaminfo="CT"
        case CS_TEAM_SPECTATOR:
            teaminfo="SPECTATOR"
    }

    if(!iMsgid_TeamInfo)
        iMsgid_TeamInfo = get_user_msgid("TeamInfo")

    message_begin(MSG_ALL, iMsgid_TeamInfo)
    write_byte(id)
    write_string(teaminfo)
    message_end()
}


stock CsTeams:fm_get_user_team(id)
{
    return CsTeams:get_pdata_int(id, OFFSET_TEAM) 
}